#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;
const ll mod = 1e9 + 7;
int main()
{
    ll n, T;
    scanf("%lld", &T);
    while (T--)
        scanf("%lld", &n), printf("%lld\n", n * (n + 1) % mod * (n + 2) % mod * (n + 3) % mod * 41666667 % mod);
    return 0;
}